Bug 225421 - rgmanager stops the resources in wrong order [RHCS5]
rgmanager stops the resources in wrong order [RHCS5]
Status: CLOSED ERRATA
Product: Red Hat Enterprise Linux 5
Classification: Red Hat
Component: rgmanager (Show other bugs)
5.0
All Linux
medium Severity medium
: ---
: ---
Assigned To: Lon Hohberger
Cluster QE
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2007-01-30 10:38 EST by Lon Hohberger
Modified: 2009-04-16 18:36 EDT (History)
1 user (show)

See Also:
Fixed In Version: RHBA-2007-0580
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2007-11-07 11:45:40 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Lon Hohberger 2007-01-30 10:38:31 EST
+++ This bug was initially created as a clone of Bug #212121 +++

the cluster.conf is:
...
<resources>
...
 <fs device="/dev/data/mt-daten" force_fsck="0" force_unmount="1" fstype="ext3"
mountpoint="/exports.smb/mt-daten" name="mt-daten" options="acl" self_fence="1"/>
 <fs device="/dev/data/zMuell" force_fsck="0" force_unmount="1" fsid="17217" fsty
pe="ext3" mountpoint="/exports.smb/mt-daten/zMuell" name="zMuell" options="acl"
self_fence="1"/>
...
</resources>
<service autostart="1" domain="storage" exclusive="1" name="storage"
recovery="restart">
...
<fs ref="mt-daten"/>
<fs ref="zMuell"/>
...
</service>
...


if I stop the rgmanger he try
to umount <fs ref="mt-daten"/> before he umounts <fs ref="zMuell"/>
that is not posible.
so he reboot the host.

the correct behavior is to umount <fs ref="zMuell"/> before <fs ref="mt-daten"/>

if he starts the rgmanager do the rigth thing:
he mounts <fs ref="mt-daten"/> befor he umounts <fs ref="zMuell"/>

-- Additional comment from lhh@redhat.com on 2006-10-25 11:58 EST --
The ordering is currently not guaranteed for a list of like-typed resources at
this point.  If you have an ordering dependency between two <fs> resources, the
way to guarantee it (right now) is:

   <service>
     <fs name="foo">
       <fs name="bar"/>
     </fs>
   </service>

If you structure your service this way, bar will always be started after foo but
stopped before foo.

Now, the historical reason for this non-guarantee was the idea that it might be
possible in the future to branch during starting/stopping of complex services -
i.e. perform operations on multiple non-codependent resources in parallel.  For
example, consider a service where two non-codependent scripts are needed which,
although not I/O or CPU intensive, each take five minutes to complete:

  <service>
    <script name="foo"/>
    <script name="bar"/>
  </service>

We could start foo and bar simultaneously, saving just about 5 minutes. 
However, the actual, *practical* use of this is very limited.  More importantly,
however, is the fact that implementation of this functionality is very likely
destabilizing.  Additionally, it would very probably break existing
start-ordering behaviors upon which, no doubt, people have already developed an
expectency.

Additionally, the practical uses of having implicit ordering guarantees vastly
exceed the theoretical "performance gain" which might (at some point) have been
attained by starting resources in parallel.

Therefore, I think we should implement implicit ordering guarantees as described.
Comment 1 Lon Hohberger 2007-03-27 16:32:07 EDT
Patches in CVS.
Comment 2 Kiersten (Kerri) Anderson 2007-04-23 13:26:48 EDT
Fixing Product Name.  Cluster Suite was integrated into the Enterprise Linux for
version 5.0.
Comment 3 RHEL Product and Program Management 2007-04-25 17:53:15 EDT
This request was evaluated by Red Hat Product Management for inclusion in a Red
Hat Enterprise Linux maintenance release.  Product Management has requested
further review of this request by Red Hat Engineering, for potential
inclusion in a Red Hat Enterprise Linux Update release for currently deployed
products.  This request is not yet committed for inclusion in an Update
release.
Comment 5 Lon Hohberger 2007-06-29 13:25:05 EDT
See bug 212121 for examples.
Comment 7 errata-xmlrpc 2007-11-07 11:45:40 EST
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHBA-2007-0580.html

Note You need to log in before you can comment on or make changes to this bug.